; routine to send a data byte out the modified cassette port
; run wire from M34 pin 12 to external pin (cassette pin 8 or BCR pin 1)
; direct connection, no filtering
; S. Adolph 
; timing for 57600 baud

; send inverted TTL (so you get TTL externally)
; start = 1 (zero)
; data is inverted
; stop = 0 (one)

KYREAD	.equ	7242H

	.org	60000d

start:				; enter with a holding byte to send

get_key:
	call	KYREAD
	jz	get_key

	
	call 	fascas

	jmp	get_key		

	
; start bit duration = 7+4+4+4+4+4+4+4+4+4 = 43
; data bit duration  = 4+10+4+4+4+4+4+4+4  = 42
; stop bit duration  = 4+7+4+4+4+4+4+7+4   = 42

; 42.65 clock cycles is ideal
; TTL Logic

fascas:
	di
	cma
	mov	c,a		; store data	
	mvi	d,01000000b	; or data
	mvi	e,10000000b	; and data
	
sendstart:
	mvi	a,11000000b	; latch one
	sim			; send start bit

	mvi	b,08d
	nop
	nop			; start bit delay

sendloop:			; send 8 bits
	mov	a,c		; get data
	rrc			; rotate bits, get carry status
	mov	c,a		; store data
				; bit is in MSB
	ana	e		; get data bit
	ora	d		; set latch

	nop			; one delay
		
	sim			; send one bit
	dcr	b
	jnz	sendloop
	
sendstop:

	nop
	nop
	nop
	nop
	nop			; last bit delay for 57600

	mvi	a,01000000b	; latch one
	sim			; send stop bit
	ret
	


	.end


